<template>
  <dashboard-layout :link="3" class="mb-5">
    <div v-if="isLoading" class="py-5 text-center">
      <vue-loaders class="py-5" name="ball-beat" color="#fa8357" scale="2"></vue-loaders>
    </div>
    <div v-else>
      <div  class="container py-2">
        <div v-if="curStep==1" class="card col-sm-10 mx-auto mt-5">
          <h4 class="text-primary2 m-2 text-center">Détails sur votre profil</h4>
          
          <div class="row p-4">
            <div class="col-sm-3">
              <div class="col-sm-12 text-center">
                <img src="../../assets/img/avatar_profile.png" alt="user avatar" class="img-fluid user-avatar2">
              </div>
              <div class="col-sm-11 mx-auto mt-3 text-center ">
                <span class="btn-edit px-3 py-1" @click="goToUpdate"> 
                  <i class="fa fa-pencil mx-2"></i> Update
                </span>
              </div>
            </div>
            <div class="col-sm-9">
              <div class="mt-3 p-2 text-dark">
                <div class="col-sm-6 ">
                  <div class="row">
                    <div class="col-sm-4"><small>Lastname:</small></div>
                    <div class="text-uppercase col-sm-8"><strong>{{user.lastname}}</strong></div>
                  </div>
                </div>
                <div class="col-sm-8 my-4">
                  <div class="row">
                    <div class="col-sm-3"><small>Firstname:</small></div>
                    <div class="text-capitalize col-sm"><strong>{{user.firstname}}</strong></div>
                  </div>
                </div>
                <div class="col-sm-8 ">
                  <div class="row">
                    <div class="col-sm-3"><small>Email:</small></div>
                    <div class="col-sm"><strong>{{user.email}}</strong>
                      <sup :class=" user.emailValidated && user.emailValidated == true ? 'text-secondary2':'text-danger' ">({{user.emailValidated && user.emailValidated == true ? 'confirmed' : 'unconfirmed' }})</sup>
                    </div>
                  </div>
                </div>
              </div>

            </div>
          </div>
        </div>
        <div v-if="curStep==2" class="card col-sm-10 mx-auto p-4 mt-5">
          <div class="row m-2">
            <div class="col-sm-2 fa-pull-left text-dark c-pointer" @click="curStep=1">
              <i class="fa fa-arrow-left mr-2"></i>
              <span class="ml-2 mt-1">Retour</span>
            </div>
          </div>
          <div class=" col-sm-8 mx-auto">
            <h4 class="text-primary2 m-2 text-center">Update Profile</h4>
            <form class=" form-horizontal my-4" @submit="updateData">
              <div class="alert alert-danger text-center mx-3" v-if="errorMessage">{{errorMessage}}</div>

              <div class="row ">
                <div :class="(checkEdit ? 'was-validated ' :' ')+' col-sm-6 form-group'">
                  <label class="text-dark" for="lastname">Lastname <sup class="text-danger">*</sup> </label>
                  <input class="form-control form-control-min text-uppercase"  required v-model="editRes.lastname"
                    minlength="2" maxlength="20" title="Au moins 2 caractères, au plus 20 caratères" 
                    placeholder="Lastname">
                  <div class="invalid-feedback">
                    Enter your Last name
                  </div>
                </div>
                <div :class="(checkEdit ? 'was-validated ' :' ')+' col-sm-6 form-group'">
                  <label class="text-dark" for="firstname">Firstname <sup class="text-danger">*</sup> </label>
                  <input class="form-control form-control-min text-capitalize"  required v-model="editRes.firstname" 
                    minlength="3" maxlength="30" title="Au moins 3 caractères, au plus 30 caratères" 
                    placeholder="Firstname">
                  <div class="invalid-feedback">
                    Enter your First name
                  </div>
                </div>

                <div :class="(checkEdit ? 'was-validated ' :' ')+' col-sm-12 form-group mt-3'">
                  <label class="text-dark" for="mail">Email <sup class="text-danger">*</sup> </label>
                  <input class="form-control form-control-min" type="email" placeholder="Enter Email address"
                    required v-model="editRes.email" >
                  <div class="invalid-feedback">
                    Enter Email address
                  </div>
                </div>

                <div :class="(checkEdit ? 'was-validated ' :' ')+' col-sm-6 mt-3'">
                  <label class="text-dark" for="password">Password  </label>
                  <div class="input-group">
                    <input :type="inputPwd ? 'password' : 'text'" v-model="password" class="form-control form-control-min" id="password"
                      placeholder="Entrez le mot de passe"
                      title="Au moins 8 caractères, un chiffre, une lettre majuscule, une lettre minuscule et un caractère spéciale" 
                      pattern="(?=.*\d)(?=.*[aA-zZ])(?=.*[-+!#*$@%_]).{8,}" aria-describedby="inputGroupPrepend">

                    <div class="input-group-prepend btn btn-outline-secondary" @click="inputPwd=!inputPwd">
                      <span  class="" id="inputGroupPrepend">
                        <i v-if="inputPwd==true" class="fa fa-eye"></i>
                        <i v-else class="fa fa-eye-slash"></i>
                      </span>
                    </div>
                    <div class="invalid-feedback"> Enter a correct Password </div>
                  </div>
                </div>

                <div v-if="password.length>0" class="col-sm-6 mt-3">
                  <label class="text-dark" for="cpassword">Confirme Password <sup class="text-danger">*</sup> </label>
                  <div class="input-group">
                    <input :type="inputConfPwd ? 'password' : 'text'" :class="'form-control form-control-min ' + (pwdNotValide ? 'is-invalid ' : 'is-valid ') "
                      id="cpassword" placeholder="Confirme Password" v-on:input="comparePwd" v-model="confirmPass"
                      title="Au moins 8 caractères, un chiffre, une lettre majuscule, une lettre minuscule et un caractère spéciale" 
                      pattern="(?=.*\d)(?=.*[aA-zZ])(?=.*[-+!#*$@%_]).{8,}" required aria-describedby="inputGroupPrepend">

                    <div class="input-group-prepend  btn btn-outline-secondary" @click="inputConfPwd=!inputConfPwd" >
                      <span class="" id="inputGroupPrepend">
                        <i v-if="inputConfPwd==true" class="fa fa-eye"></i>
                        <i v-else class="fa fa-eye-slash"></i>
                      </span>
                    </div>
                    <div v-if="pwdNotValide==true" class="invalid-feedback">
                      Mot de passe non conforme
                    </div>
                    <div v-else class="invalid-feedback">
                      Confirmez votre mot de passe
                    </div>
                  </div>
                </div>

                <div class="col-sm-12 mt-4 text-center" @click="checkEdit=true">
                  <button class="btn btn-edit px-5 text-white btn-block waves-effect waves-light" type="submit">Update</button>
                </div>
              </div>
            </form>
          </div> 
        </div>
      </div>
    </div>
  </dashboard-layout>
</template>

<script lang="ts">

export default {
  data() {
    return {
      user: {},
      isLoading: false,
      errorMessage: '',

      customer: {},
      total: 0,
      curStep: 1,

      editRes: {},
      checkEdit: false,
      confirmPass: '',
      inputPwd: true,
      inputConfPwd: true,
      password: '',
      pwdNotValide: true,

    };
  },
  mounted() {
    this.init();
  },
  methods: {
    init(){
      if(localStorage.getItem('token') ){
        this.user = JSON.parse(localStorage.getItem('userInfos'));
				console.log('User infos : ', this.user );
      }
    },
    updateData(){
      if(this.password.length > 0){
        if(this.password != this.confirmPass){
          return this.errorMessage = "Mot de passe non conforme!";
        } else {
          this.editRes.password = this.password;
          this.updateRequest();
        }

      } else {
        if(this.user.firstname == this.editRes.firstname && this.user.lastname == this.editRes.lastname 
          && this.password.length == 0 ){
          this.$alertify.warning("Aucune mises à jour trouvée !");
          
        } else {
          this.updateRequest();
        }
      }

    },
    updateRequest(){
      this.isLoading = true;

      const userInfos = {
        lastname: this.editRes.lastname,
        firstname: this.editRes.firstname,
        password: this.editRes.password,
      }

      this.$service.putLogged("users/update/"+this.user.id+"", userInfos, (data) => {
        this.isLoading = false;

        if(data.status==200){
          this.curStep = 1;
          this.editRes = {}

          localStorage.setItem('userInfos', JSON.stringify(data.user));
          this.init();
          this.$alertify.success("Vous informations ont bien été mises à jour !");

        } else {
          if(data.status == 401){
            this.$alertify.error("Access denied");
          }

          return this.errorMessage = data.message;
          
        }
      });
      
    },
    goToUpdate(){
      this.curStep = 2;
      this.checkEdit = false;
      this.password = '';
      this.confirmPass = '';

      this.editRes.email = this.user.email;
      this.editRes.firstname = this.user.firstname;
      this.editRes.lastname = this.user.lastname;
    },
    comparePwd(){
      if(this.password.length>7){
        if(this.password != this.confirmPass){
          this.pwdNotValide = true;
        } else {
          this.pwdNotValide = false;
        }
      }
      
    }
  },
};
</script>

<style lang="scss" scoped>

  .user-profil {
    padding: 30px;
    width: 160px;
    height: 150px;
    font-size: 70px;
    border-radius: 5px;
    color: #fff;
    background-color: #78b843;
    text-align: center;
  }
</style>
